Package: hdxmsqc
Type: Package
Title: An R package for quality Control for hydrogen deuterium exchange
        mass spectrometry experiments
Version: 1.7.0
Authors@R: c(person(family = "Crook", given = "Oliver M.",
		                email = "oliver.crook@stats.ox.ac.uk",
		                comment = c(ORCID = "0000-0001-5669-8506"),
		                role = c("aut", "cre")))
Description: The hdxmsqc package enables us to analyse and visualise the quality
 of HDX-MS experiments. Either as a final quality check before downstream
 analysis and publication or as part of a interative procedure to determine
 the quality of the data. The package builds on the QFeatures and Spectra
 packages to integrate with other mass-spectrometry data.
License: file LICENSE
Encoding: UTF-8
LazyData: false
Depends: R(>= 4.3), QFeatures, S4Vectors, Spectra
Imports: dplyr, tidyr, ggplot2, BiocStyle, knitr, methods, grDevices,
        stats, MsCoreUtils
Suggests: RColorBrewer, pheatmap, MASS, patchwork, testthat
VignetteBuilder: knitr
Roxygen: list(markdown=TRUE)
RoxygenNote: 7.2.3
biocViews: QualityControl,DataImport, Proteomics, MassSpectrometry,
        Metabolomics
BugReports: https://github.com/ococrook/hdxmsqc/issues
URL: http://github.com/ococrook/hdxmsqc
Language: en-US
git_url: https://git.bioconductor.org/packages/hdxmsqc
git_branch: devel
git_last_commit: 1520631
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: no
Packaged: 2025-10-31 22:16:18 UTC; biocbuild
Author: Oliver M. Crook [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5669-8506>)
Maintainer: Oliver M. Crook <oliver.crook@stats.ox.ac.uk>

[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)

# The `hdxmsqc` package

The [**hdxmsqc**] (Hydrogen-Deuterium Exchange Mass spectrometry quality control)
package is an R/Bioconductor package for HDX-MS quality control. The package
allows the enconding of experimental design, dedicated storage, quality
control visualisation and metrics. Whilst many tools metrics are difficult
to understand, unintpretable or rely on using a particular preprocessing software.
`hdxmsqc` can examine any data that can be formatted correctly into a `QFeatures`
object.

# Installation requirements

Users will require a working version of R, currently at least version >4.
It is recommended to use [RStudio](https://www.rstudio.com). The package can 
then be installed using the `devtools` package. The package should take a few 
minutes to install on a regular desktop or laptop. The package will need to be
loaded using `library(hdxmsqc)`

# Basic ideas and concepts

The [`hdxmsqc`] package implements quality control metrics for hdx-ms data.
Data from form such experiments most commonly yield a matrix of measurements 
where we have peptides along the rows, and samples (timepoints/conditions)
along the columns. Assessing the quality of `hdxmsqc` data can be challenging
and laborious. This package seeks to streamline this analysis and provide
a uniform way to present quality control of data.


To use `hdxmsqc` the data must be stored as a `QFeatures`/`Spectra`, as
implemented in the Bioconductor 
[`RForMassSpectrometry`](https://www.rformassspectrometry.org/) packages. There
are functions within the package to coherse the data into the correct format.

# Vignettes

There is currently one vignette in the package which runs through
the analysis. Analysis is designed to be quick. Though assessing the quality
of Spectra can take longer.

# Documentation

Functions are documented and be founded in the `Help`

# Contribution

Contributions are welcome, please open an issue so ew can discuss any contribution
in advance

# Feature requests

This package is actively being developed and maintained, please open Github
issue if you would like to request or discuss a particular feature.

# Licensing

The package is free to use for academic and commerical users at no cost.
Commerical users who need help installing on internal systems or more elaborate
requests designed for their infrastructure may contact us.

#' Quality Control table function. Generate a table that collates quality
#' control metrics
#' @param object An object of class Qfeatures, with the data used for the analysis
#' @param massError The output of the `computeMassError` function
#' @param intensityOutlier The output of the `intensityOutliers` function
#' @param retentionOutlier The output of the `rTimeOutliers` function
#' @param monotonicityStat The output of the `computeMonotoneStats` function
#' @param mobilityOutlier The output of the `imTimeOutliers` function
#' @param chargeCorrelation The output of the `chargeCorrelationsHdx` function
#' @param replicateCorrelation The output of the `replicateCorrelation` function
#' @param replicateOutlier The output of the `replicateOutlier` function
#' @param sequenceCheck The output of the `compatibleUptake` function
#' @param spectraCheck The output of the `spectraSimiarity` function
#' @param experiment The experimental conditions.
#' @param timepoints The timepoints used in the analysis, must include repeat
#' for replicates
#' @param undeuterated A logical indicating whether only the undeuterated data 
#' should be exported 
#' @return An object of class `DataFrame` containing a summary of the quality
#' control results.
#' @md
#' @author Oliver Crook
#' @export 
qualityControl <- function(object, 
                           massError = NULL,
                           intensityOutlier = NULL,
                           retentionOutlier = NULL,
                           monotonicityStat = NULL,
                           mobilityOutlier = NULL,
                           chargeCorrelation = NULL,
                           replicateCorrelation = NULL,
                           replicateOutlier = NULL,
                           sequenceCheck = NULL,
                           spectraCheck = NULL,
                           experiment = NULL,
                           timepoints = NULL,
                           undeuterated = FALSE){
    
    
    QCtable <- DataFrame(sequence = massError$sequence)
    QCtable$timepoints <- rep(rep(timepoints,
                                  times = length(experiment)),
                                  times = length(unique(massError$sequence)))
    QCtable$experiment <- rep(rep(experiment,
                                  each = length(timepoints)),
                                  times = length(unique(massError$sequence)))
    QCtable$replicate <- as_tibble(QCtable) |>  group_by(sequence, timepoints, experiment) |>
        mutate(replicate = row_number()) |> pull(replicate)
    
    ## Get start and end
    i <- grep(pattern = "Start", x = rowDataNames(object)[[1]])
    j <- grep(pattern = "End", x = rowDataNames(object)[[1]])
    startend <- rowData(object[[1]])[,c(i[1], j[1])]
    QCtable$Start <- 0
    QCtable$End <-0
    QCtable[, c("Start", "End")] <- startend[QCtable$sequence,]
    
    ## Get score from software (e.g. HDExaminer)
    i <- grep(pattern = "Score", x = rowDataNames(object)[[1]])
    HDscore <- data.frame(rowData(object[[1]])[, i])
    QCtable$HDScore <- 0 
    QCtable$HDScore <- c(t(HDscore))
    
    
    
    
    if (is.null(massError)){
        QCtable$massCheck <- 0
    } else{
        QCtable$massCheck <- 1 * (abs(massError$y) > 300)
    }    

    if (is.null(intensityOutlier)){
        QCtable$intensityCheck <- 0 
    } else{
        iOut <- which(QCtable$sequence %in%
                      intensityOutlier$x[intensityOutlier$outlier == 1])
    
        QCtable$intensityCheck <- 0
        QCtable$intensityCheck[iOut] <- 1
    }

    if (is.null(retentionOutlier)){
        QCtable$retentionOutlier <- 0
    } else{
        QCtable$retentionOutlier <- apply(rbind(retentionOutlier$leftRT$outlier,
                                    retentionOutlier$rightRT$outlier), 2, max)
    }
    

    if (is.null(monotonicityStat)){
        QCtable$monotonicityStat <- 0
    } else{
            QCtable$monotonicityStat <- 0
    for (i in seq_along(experiment)){
          monoOut <- which(QCtable$sequence %in% 
                         monotonicityStat[[i]]$x[monotonicityStat[[i]]$outlier == 1])
          wh <- which(QCtable$experiment %in% experiment[[i]])
          
    n <- length(QCtable$monotonicityStat[intersect(wh, monoOut)])      
    QCtable$monotonicityStat[intersect(wh, monoOut)] <- rep(1, n)
    }
    }
    
    if (is.null(mobilityOutlier)){
        QCtable$mobilityOutlier <- 0
    } else {
            
        QCtable$mobilityOutlier <- apply(rbind(mobilityOutlier$leftIMS$outlier,
                                    mobilityOutlier$rightIMS$outlier), 2, 
                                   max)
    }

    if (is.null(chargeCorrelation)){
        QCtable$chargecorrelation <- 0
    } else{
    QCtable$chargecorrelation <- 0
    for (i in seq_along(experiment)){
        cRes <- colSums(chargeCorrelation[[i]] < 0.9, na.rm = TRUE) >= 1
        wC <- cRes[cRes]
        seq <- sapply(strsplit(QCtable$sequence, split = ""),
                      function(x) paste(x[seq.int(length(x)) - 1],
                                        sep = "", collapse = ""))
        sub1 <- QCtable$experiment %in% experiment[[i]]
        sub2 <- seq %in% names(wC)
        QCtable$chargecorrelation[sub1 & sub2] <- 1
    }
    }
    
    # Replicate-based check 1
    
    if(is.null(replicateCorrelation)){
        QCtable$replicatecorrelation <- 0
    } else{
        QCtable$replicatecorrelation <- 0
        
        for (i in seq_along(experiment)){
            
            rcRes <- as.numeric(replicateCorrelation[[i]]$outlier) == 1
            rcC <- replicateCorrelation[[i]]$x[rcRes]
            sub1 <- QCtable$experiment %in% experiment[[i]]
            sub2 <- QCtable$sequence %in% rcC
            
            QCtable$replicatecorrelation[sub1 & sub2] <- 1 
            
        }
    }
    
    # Replicated-based check 2
    if(is.null(replicateOutlier)){
        QCtable$replicateoutlier <- 0
    } else{
        QCtable$replicateoutlier <- 0
        
        for (i in seq_along(experiment)){
            
            rcRes <- as.numeric(replicateOutlier[[i]]$outlier) == 1
            rcC <- replicateOutlier[[i]]$x[rcRes]
            sub1 <- QCtable$experiment %in% experiment[[i]]
            sub2 <- QCtable$sequence %in% rcC
            
            QCtable$replicateoutlier[sub1 & sub2] <- 1 
        }
    }
    
    
    
    
    if (is.null(sequenceCheck)){
        QCtable$sequenceCheck <- 0
    } else{
            QCtable$sequenceCheck <- 0
        for (j in seq_along(sequenceCheck)){
            ex <- gsub("([0-9]+).*$","", sequenceCheck[[j]])
            time <- as.numeric(gsub(".*?([0-9]+).*", "\\1", sequenceCheck[[j]]))
        
            whseqCheck <- which((QCtable$sequence %in% names(sequenceCheck[[j]])) &
                                (QCtable$timepoints %in% time) &
                                (QCtable$experiment %in% ex))
        
            QCtable$sequenceCheck[whseqCheck] <- 1 
        }
    }



    # spit out fully deuterated samples
    spectraCheck$observedSpectra <- spectraCheck$observedSpectra[spectraCheck$observedSpectra$DeutTime != "FD",]

    # convert times seconds, currently as character:
    spectraCheck$observedSpectra$DeutTime <- vapply(strsplit(spectraCheck$observedSpectra$DeutTime, "s"),
                                       function(x) as.numeric(x),
                                       FUN.VALUE = numeric(1))
    
    if (is.null(spectraCheck)){
        QCtable$score <- 0
        
    } else {
        for (j in seq_along(experiment)){
            i <- grep(experiment[j], spectraCheck$observedSpectra$experiment)
            spectraCheck$observedSpectra$experiment[i] <- experiment[j]
        }
    
    charge <- sapply(strsplit(QCtable$sequence, split = ""),
                                    function(x) paste(x[length(x)],
                                                      sep = "", collapse = ""))
    QCtable$score <- NA
    
        for (j in seq.int(nrow(QCtable))){
            wh <- spectraCheck$observedSpectra$Sequence == seq[j] &
                spectraCheck$observedSpectra$Charge == charge[j]
            wh2 <- spectraCheck$observedSpectra$DeutTime == QCtable$timepoints[j] &
                spectraCheck$observedSpectra$experiment == QCtable$experiment[j] &
                spectraCheck$observedSpectra$replicate == QCtable$replicate[j]
            QCtable$score[j] <- max(spectraCheck$observedSpectra$score[which(wh & wh2)],
                                0) # give 0 to missing spectra
        }
    }

    
    QCtable$flagged <- rowSums(as.matrix(QCtable[, -(c(seq.int(7), which(colnames(QCtable) == "score")))]))
    
    if(isTRUE(undeuterated)){
        QCtable <- QCtable[QCtable$timepoints == 0,]
    }
    
    return(QCtable)
}

# The setting of R_TESTS exists to work around an R bug. See
# https://github.com/hadley/testthat/issues/144
# We should remove it when the issue is resolved.
Sys.setenv("R_TESTS" = "")

library("testthat")
library("hdxmsqc")

test_check("hdxmsqc")

#' fourier transform approach to computing isotopic distribution
#' @param elements A list of elements
#' @param incorp The deuterium incoperation
#' @param num_exch_sites The number of exchangable amides. Default is 0.
#' @param charge The charge state of the peptide
#' @param isotopes The number of isotopes to compute. The default is NULL, in whiich
#' a default heuristic is used to make a good guess that covers the expected peaks.
#' @return A list of mass and intensity value corresponding to the isotope distribution
#' @md
#' @examples
#' fourierIsotope(c(C = 0, H = 2, N = 0, O = 1, S = 0, P = 0))
#' 
#' @author Oliver Crook
#' @export
fourierIsotope <- function(elements,
                           incorp = 0,
                           num_exch_sites = 0,
                           charge = 1,
                           isotopes = NULL){
    
    ## add in charge
    el <- c(elements, charge)
    el["H"] <- el["H"] - num_exch_sites
    el["D"] <- num_exch_sites
    el <- el[names(el) != "P"]
    
    # infilling with zeros to make matricies match
    
    ## carbon details
    cmass <- c(12.0000000, 13.0033548378, 0, 0)
    cprob <- c(0.9893, 0.0107, 0, 0)


    ## expected mass of unexchanged hydrogens
    hmass <- c(1.0078250321, 2.0141017780, 0, 0)
    hprob <- c(0.999885, 0.000115, 0, 0)

    ## expected mass of exchanged hydrogens
    dmass <- c(1.0078250321, 2.0141017780, 0, 0)
    dprob <- c(1 - incorp, incorp, 0, 0)

    ## expected mass of nitrogens
    nmass <- c(14.0030740052, 15.0001088984, 0, 0)
    nprob <- c(0.99632, 0.00368, 0, 0)


    ## expected mass of oxygens 
    omass <- c(15.9949146221, 16.99913150, 17.9991604, 0)
    oprob <- c(0.99757, 0.00038, 0.00205, 0)

    ## expected mass of sulphers
    smass <- c(31.97207069, 32.97145850, 33.96786683, 35.96708088)
    sprob <- c(0.9493, 0.0076, 0.0429, 0.0002)

    ## expected mass of charge
    chmass <- c(1.0072764522, 2.0135531981, 0, 0)
    chprob <- c(0.999885, 0.000115, 0 , 0)

    # Must be in the same order as elments
    prob <- rbind(cprob, hprob, nprob, oprob, sprob, chprob, dprob)
    mass <- rbind(cmass, hmass, nmass, omass, smass, chmass, dmass)
    

    # guess sensible isotopes to compute
    if(is.null(isotopes)){
        isotopes <- max(4,
                        0.5 * sqrt(1 + sum(el * apply(mass,1, function(x) var(x[x!=0])))))
        isotopes <- floor(isotopes)
    }
    # isotopic expansion
    isotopes <- isotopes + num_exch_sites
    
    # make to size of isotopes required
    finalProb <- matrix(0, nrow = nrow(prob), ncol = isotopes)
    finalMass <- matrix(0, nrow = nrow(prob), ncol = isotopes)
    finalProb[, seq.int(4)] <- prob
    finalMass[, seq.int(4)] <- mass
    
    # isotope distribution of elements
    # fourier transform of probability
    fa <- t(apply(finalProb, 1, fft))
    # expsumlog trick for stability
    a <- exp(colSums(el * log(fa)))
    # Compute probability distribution of isotopes, correct normalising const 
    pout <- fft(a, inverse = TRUE)/length(a) 
    # Compute weighted mass matrix
    b <- finalProb * finalMass
    # fourier transform
    fb <- t(apply(b, 1, fft))
    #Compute ratio
    fr <- fb/fa
    # mass distribution of el, correct normalising const
    bout <- fft(colSums(el * fr) * a, inverse = TRUE)/length(pout)
    m <- bout/pout 
    
    if(charge != 0 ) mz <- m/charge
    else mz <- m
    
    return(list(intensity = Re(pout), mz = Re(mz)))
}    
#' fourier transform approach to computing isotopic distribution
#' 
#' @param sequence A peptide
#' @param incorp The deuterium incoperation
#' @param charge The charge state of the peptide
#' @param custom custom amino acids can be provided here provide a list
#' of the elements. 
#' @return A list of mass and intensity value corresponding to the isotope distribution
#' @md
#' @examples 
#' isotopicDistributionHDXfourier(sequence = "HDAEHAHEAPRKL")
#' @author Oliver Crook
#' @export
isotopicDistributionHDXfourier <- function(sequence,
                                           incorp = 0,
                                           charge = 1, 
                                           custom = list(code = NULL, elements = NULL)) {
    
    if(length(custom$elements != 0)) {
        custom_elements <- c(C = 0, H = 0, N = 0, O = 0, S = 0, P = 0)
        custom_elements[names(custom$elements)] <- custom$elements
    }
    
    if(charge < 0 | charge > 8) stop("charge must be between 1 and 8")
    
    # create vector for sequences and holder for element annotations
    seq_vector <- strsplit(sequence, split = "")[[1]]
    x <- c(C = 0, H = 0, N = 0, O = 0, S = 0, P = 0)
    
    # Update x with amino acid information
    for(i in seq.int(length(seq_vector))) {
        if(seq_vector[i] == "A") x <- x + c(C = 3, H = 5, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "R") x <- x + c(C = 6, H =12, N = 4, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "N") x <- x + c(C = 4, H = 6, N = 2, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "D") x <- x + c(C = 4, H = 5, N = 1, O = 3, S = 0, P = 0)
        if(seq_vector[i] == "C") x <- x + c(C = 3, H = 5, N = 1, O = 1, S = 1, P = 0) 
        if(seq_vector[i] == "E") x <- x + c(C = 5, H = 7, N = 1, O = 3, S = 0, P = 0)
        if(seq_vector[i] == "Q") x <- x + c(C = 5, H = 8, N = 2, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "G") x <- x + c(C = 2, H = 3, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "H") x <- x + c(C = 6, H = 7, N = 3, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "I") x <- x + c(C = 6, H =11, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "L") x <- x + c(C = 6, H =11, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "K") x <- x + c(C = 6, H =12, N = 2, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "M") x <- x + c(C = 5, H = 9, N = 1, O = 1, S = 1, P = 0)
        if(seq_vector[i] == "F") x <- x + c(C = 9, H = 9, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "P") x <- x + c(C = 5, H = 7, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "S") x <- x + c(C = 3, H = 5, N = 1, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "T") x <- x + c(C = 4, H = 7, N = 1, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "W") x <- x + c(C =11, H =10, N = 2, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "Y") x <- x + c(C = 9, H = 9, N = 1, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "V") x <- x + c(C = 5, H = 9, N = 1, O = 1, S = 0, P = 0)
        
        if(length(custom$elements != 0))
            if(seq_vector[i] == custom$code) x <- x + custom_elements    
    }
    
    ## add N-terminal H and C-terminal OH
    elements <- x + c(C = 0, H = 2, N = 0, O = 1, S = 0, P = 0) 
    
    # get the number of exchangeable amides
    num_exch_sites <- exchangeableAmides(sequence)
    
    ## compute distribution using fourier method 
    res  <- fourierIsotope(elements = elements,
                           incorp = incorp,
                           num_exch_sites = num_exch_sites,
                           charge = charge,
                           isotopes = NULL)
    
    intensity <- as.numeric(res$intensity)
    mz <- as.numeric(res$mz)
    mz <- mz[!(intensity < 10^{-8})]
    omz <- order(mz)
    mz <- mz[omz]
    intensity <- intensity[!(intensity < 10^{-8})]
    intensity <- intensity[omz]
    
    # generate spectra object
    spec <- DataFrame(
        msLevel = c(1L),
        charge = charge,
        sequence = sequence)
    
    spec$mz <- list(mz)
    spec$intensity <-  list(intensity)
    
    # construct spectra object
    sps <- Spectra(spec)
    
    return(sps)
    
}

##' Computes the number of exchangeable amides based on the sequnece
##' @title Compute exchangeable amides.
##' @param sequence The sequence of the peptide
##' @return Returns a numeric indicating the number of exchangeable amides
##' @md
##' @examples
##' 
##' exchangeableAmides(sequence = "HDAEHAHEAPRKL")
##' @rdname hdx-distributions
exchangeableAmides <- function(sequence) {
    
    n <- length(sequence)
    x <- vector(mode = "numeric", length = n)
    
    for(i in seq.int(n)) {
        seq_vector <- strsplit(as.character(sequence[i]), split = "")[[1]]
        x[i] <- length(na.omit(sub("P", NA, seq_vector))) - 2
    }
    
    return(x)	
}

isotopicDistributionHDXfourier <- function(sequence,
                                           incorp = 0,
                                           charge = 1, 
                                           custom = list(code = NULL, elements = NULL)) {
    
    if(length(custom$elements != 0)) {
        custom_elements <- c(C = 0, H = 0, N = 0, O = 0, S = 0, P = 0)
        custom_elements[names(custom$elements)] <- custom$elements
    }
    
    if(charge < 0 | charge > 8) stop("charge must be between 1 and 8")
    
    # create vector for sequences and holder for element annotations
    seq_vector <- strsplit(sequence, split = "")[[1]]
    x <- c(C = 0, H = 0, N = 0, O = 0, S = 0, P = 0)
    
    # Update x with amino acid information
    for(i in seq.int(length(seq_vector))) {
        if(seq_vector[i] == "A") x <- x + c(C = 3, H = 5, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "R") x <- x + c(C = 6, H =12, N = 4, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "N") x <- x + c(C = 4, H = 6, N = 2, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "D") x <- x + c(C = 4, H = 5, N = 1, O = 3, S = 0, P = 0)
        if(seq_vector[i] == "C") x <- x + c(C = 3, H = 5, N = 1, O = 1, S = 1, P = 0) 
        if(seq_vector[i] == "E") x <- x + c(C = 5, H = 7, N = 1, O = 3, S = 0, P = 0)
        if(seq_vector[i] == "Q") x <- x + c(C = 5, H = 8, N = 2, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "G") x <- x + c(C = 2, H = 3, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "H") x <- x + c(C = 6, H = 7, N = 3, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "I") x <- x + c(C = 6, H =11, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "L") x <- x + c(C = 6, H =11, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "K") x <- x + c(C = 6, H =12, N = 2, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "M") x <- x + c(C = 5, H = 9, N = 1, O = 1, S = 1, P = 0)
        if(seq_vector[i] == "F") x <- x + c(C = 9, H = 9, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "P") x <- x + c(C = 5, H = 7, N = 1, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "S") x <- x + c(C = 3, H = 5, N = 1, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "T") x <- x + c(C = 4, H = 7, N = 1, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "W") x <- x + c(C =11, H =10, N = 2, O = 1, S = 0, P = 0)
        if(seq_vector[i] == "Y") x <- x + c(C = 9, H = 9, N = 1, O = 2, S = 0, P = 0)
        if(seq_vector[i] == "V") x <- x + c(C = 5, H = 9, N = 1, O = 1, S = 0, P = 0)
        
        if(length(custom$elements != 0))
            if(seq_vector[i] == custom$code) x <- x + custom_elements    
    }
    
    ## add N-terminal H and C-terminal OH
    elements <- x + c(C = 0, H = 2, N = 0, O = 1, S = 0, P = 0) 
    
    # get the number of exchangeable amides
    num_exch_sites <- exchangeableAmides(sequence)
    
    ## compute distribution using fourier method 
    res  <- fourierIsotope(elements = elements,
                           incorp = incorp,
                           num_exch_sites = num_exch_sites,
                           charge = charge,
                           isotopes = NULL)
    
    intensity <- as.numeric(res$intensity)
    mz <- as.numeric(res$mz)
    mz <- mz[!(intensity < 10^{-8})]
    omz <- order(mz)
    mz <- mz[omz]
    intensity <- intensity[!(intensity < 10^{-8})]
    intensity <- intensity[omz]
    
    # generate spectra object
    spec <- DataFrame(
        msLevel = c(1L),
        charge = charge,
        sequence = sequence)
    
    spec$mz <- list(mz)
    spec$intensity <-  list(intensity)

    return(spec)
}
#' generate Spectra using a fourier transform
#' @param sequences A vector of peptide sequences
#' @param incorps A vector of deuterium incoperation
#' @param charges A vector of charge states of the peptide
#' @param customs Custom elements supplied as a list
#' @return A Spectra object corresponding to the isotope distributions
#' @md
#' @author Oliver Crook
#' @examples
#' generateSpectra(sequence = "HDAEHAHEAPRKL", incorps = c(0.5), charges = 2)
#' 
#' @export
generateSpectra <- function(sequences,
                            incorps, 
                            charges,
                            customs = list(code = NULL, elements = NULL)){
    
    n <- length(sequences)
    out <- lapply(seq.int(n), function(n)
                        isotopicDistributionHDXfourier(sequence = sequences[n],
                                                       incorp = incorps[n],
                                                       charge = charges[n],
                                                       custom = list(code = NULL, elements = NULL)))
    
    spd <- do.call(rbind, out)
    spec <- Spectra(spd)
    
    return(spec)
}

#' This is data to be included in my package
#'
#' @name BRD4df
#' @description
#' 
#' A small HDX-MS dataset for BRD4 in apo state and in complex with IBET151. 
#' This data was generated by GSK and is available for re-use under the package
#' license. The data was first published in Crook et al. 2024 Functional
#' Bayesian model for hydrogen deuterium exchange mass spectrometry, JPR. The
#' data is an object of class `QFeatures` and has been downsampled to 10 peptides
#' and 1 condition to provide example data. See `data("BRD4df_full")` for the
#' complete dataset
#' 
#' @docType data
#' @author Oliver Crook \email{ococrook@gmail.com}
#' @keywords data
NULL

#' This is data to be included in my package
#'
#' @name BRD4df_full
#' @description
#' 
#' A complete HDX-MS dataset for BRD4 in apo state and in complex with IBET151.
#' This data was generated by GSK and is available for re-use under the package
#' license. The data was first published in Crook et al. 2024 Functional
#' Bayesian model for hydrogen deuterium exchange mass spectrometry, JPR. The
#' data is an object of class `QFeatures` and the data has been parsed from a
#' HDExaminer file without filtering or processing. The data contains 179 peptides
#' across 36 samples. THis includes 3 replicate experiments, 2 conditions and
#' 6 timepoints.
#' 
#' 
#' @docType data
#' @author Oliver Crook \email{ococrook@gmail.com}
#' @keywords data
NULL

#' Function to curate and HDExaminer file so that in contains all the information
#' in a sensible format. This object can then be straightforwardly passed to
#' a object of class `QFeatures`
#' 
#' 
#' @param HDExaminerFile an object of class data.frame containing an HDExaminer
#' data
#' @param proteinStates a character vector indicating the protein states
#' @md
#' @rdname processHDE
#' @author Oliver Crook
#' @examples
#' sample_data <- data.frame(read.csv(system.file("extdata", "ELN55049_AllResultsTables_Uncurated.csv", package = "hdxmsqc", mustWork = TRUE), nrows = 10))
#' 
#' processHDE(sample_data) 
#' 
#' @return A wide format data frame with HDExaminer data
#' @export
processHDE <- function(HDExaminerFile, proteinStates = NULL){
    
    stopifnot("Not a data.frame"=is(HDExaminerFile, "data.frame"))
    
    numSeq <- length(unique(HDExaminerFile$Sequence))
    numTimepoints <- length(unique(HDExaminerFile$Deut.Time))
    numStates <- length(unique(HDExaminerFile$Protein.State))
    
    message("Number of peptide sequence: ", numSeq, 
            "\nNumber of timepoints: ", numTimepoints,
            "\nNumber of Protein States: ", numStates)
    
    # processing steps
    # Convert n/a s to NA
    HDExaminerFile[HDExaminerFile == "n/a"] <- NA
    
    # Making RT and IMS into reasonable left and right windows
    HDExaminerFile$leftRT <- 0
    HDExaminerFile$rightRT <- 0
    HDExaminerFile$leftIMS <- 0
    HDExaminerFile$rightIMS <- 0

    # assumes data are stored as "x1-x2"
    left_right_Rt <- t(vapply(strsplit(HDExaminerFile$Actual.RT,
                                       fixed = TRUE, split = "-"),
                              function(x) as.numeric(x[seq.int(2)]),
                              FUN.VALUE = numeric(2))) 
    left_right_ims <-  t(vapply(strsplit(HDExaminerFile$IMS.Range,
                                         fixed = TRUE, split = "-"),
                                function(x) as.numeric(x[seq.int(2)]),
                                FUN.VALUE = numeric(2))) 

    # Put in dataframe
    HDExaminerFile[, c("leftRT", "rightRT")] <- left_right_Rt
    HDExaminerFile[, c("leftIMS", "rightIMS")] <- left_right_ims
    
    # spit out fully deuterated samples
    HDExaminerFile_fd <- HDExaminerFile[HDExaminerFile$Deut.Time == "FD",]
    HDExaminerFile <- HDExaminerFile[HDExaminerFile$Deut.Time != "FD",]
    
    # convert times seconds, currently as character:
    HDExaminerFile$Deut.Time <- vapply(strsplit(HDExaminerFile$Deut.Time, "s"),
                                      function(x) as.numeric(x),
                                      FUN.VALUE = numeric(1))

    # add in repliate numbers
    HDExaminerFile <- HDExaminerFile |> 
        group_by(Deut.Time, Sequence, Protein.State, Charge) |>
        mutate(replicate = row_number())

    # remove annoying spaces in files and replace with 0
    # also convert to numeric
    HDExaminerFile$X..Deut[HDExaminerFile$Deut.. == ""] <- 0
    HDExaminerFile$Deut..[HDExaminerFile$Deut.. == ""] <- 0
    HDExaminerFile$Deut.. <- as.numeric(HDExaminerFile$Deut..)
    HDExaminerFile$X..Deut <- as.numeric(HDExaminerFile$X..Deut)

    if (is.null(proteinStates)){
        proteinStates <- paste0(rep("Condition ", numStates), seq.int(numStates))
        proteinStatesCurrent <- unique(HDExaminerFile$Protein.State)
        for (j in seq_along(proteinStatesCurrent)){
            HDExaminerFile$Protein.State[HDExaminerFile$Protein.State 
                                         == proteinStatesCurrent[j]] <- proteinStates[j]

        }
    } else{
        stopifnot("proteinStates does not match
                  number of states"=numStates==length(proteinStates))
        proteinStatesCurrent <- unique(HDExaminerFile$Protein.State)
        for (j in seq_along(proteinStatesCurrent)){
            HDExaminerFile$Protein.State[HDExaminerFile$Protein.State 
                                         == proteinStatesCurrent[j]] <- proteinStates[j]
            
        }
    }    

    # convert to wide format
    HDExaminerFile_wide <- pivot_wider(data = HDExaminerFile,
                                       id_cols = c("Sequence",
                                                   "Charge"),
                                       names_from = c("Protein.State",
                                                      "Deut.Time",
                                                      "replicate"),
                                       values_from = c("X..Deut",
                                                       "Search.RT",
                                                       "Actual.RT",
                                                       "X..Spectra",
                                                       "Search.IMS",
                                                       "IMS.Range",
                                                       "Max.Inty",
                                                       "Exp.Cent",
                                                       "Theor.Cent",
                                                       "Score",
                                                       "Confidence",
                                                       "leftRT",
                                                       "rightRT",
                                                       "leftIMS",
                                                       "rightIMS",
                                                       "X..Spectra",
                                                       "Start",
                                                       "End"))
    # make feature names
    HDExaminerFile_wide$fnames <- paste0(HDExaminerFile_wide$Sequence,
                                         HDExaminerFile_wide$Charge)
    
    return(HDExaminerFile_wide)

}

#' missing value plot
#' 
#' @param object An object of class `QFeatures`
#' @param ... Additional arguemnts to pheatmap
#' @md
#' @examples
#' data("BRD4df_full")
#' library(pheatmap)
#' library(RColorBrewer)
#' 
#' plotMissing(BRD4df_full)
#' 
#' 
#' @return a pheatmap showing missing values
#' @author Oliver Crook
#' @export
plotMissing <- function(object, ...){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    na_mat <- 1*is.na(assay(object))
    pheatmap(na_mat, 
             cluster_rows = FALSE,
             cluster_cols = FALSE,
             color = brewer.pal(n = 3, name = "Greys")[c(1, 3)],
             legend_breaks = c(0,1),
             legend_labels = c("Not Missing", "Missing"),
             main = "Missing value plot",
             fontsize = 12,...)
    
}
#'Missing at random versus missing not at random
#'
#'@param object An object of class `QFeatures`
#'@param threshold A threshold indicated how many missing values indicate
#'whether missingness is not at random. Default is NULL, which means leads to a
#'threshold which is half the number of columns.
#'@param filter A logial indicating whether to filter out data that is deemed
#' missing not at random
#'
#'
#' data("BRD4df_full")
#' 
#' isMissingAtRandom(BRD4df_full)
#'
#'@return Adds a missing not at random indicator column  
#'@author Oliver Crook 
#'@md
#'@export 
isMissingAtRandom <- function(object, threshold = NULL, filter = TRUE){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    na_mat <- 1*is.na(assay(object))
    if (is.null(threshold)){
        threshold <- ncol(na_mat)/2
    }
    
    to_filter_missing <- 1*(rowSums(na_mat) > threshold)
    rowData(object)[[1]]$mnar <- to_filter_missing
    
    if (isTRUE(filter)){
        object <- filterFeatures(object, ~ mnar != 1,) 
        message("Number of peptides filtered:", sum(to_filter_missing))   
    }

    
    return(object)
    
}
#'Empirical versus theoretical mass errors
#'
#'@param object An object of class `QFeatures`
#'@param eCentroid character string indicating column identifier for 
#'experimental centroid
#'@param tCentroid character string indicating column identifier for 
#'theoretical centroid
#'@return The error difference between the empirical and theoretical centroid
#'@md
#'@examples
#' data("BRD4df")
#' result <- computeMassError(BRD4df, "Exp.Cent", "Theor.Cent")
#' head(result)
#'@author Oliver Crook
#'@export
computeMassError <- function(object,
                             eCentroid = "Exp.Cent",
                             tCentroid = "Theor.Cent"){
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    j <- grep(pattern = eCentroid, x = rowDataNames(object)[[1]])
    k <- grep(pattern = tCentroid, x = rowDataNames(object)[[1]])
    
    deltaPPM <- ((as.matrix(rowData(object)[[1]][, j]) - 
                      as.matrix(rowData(object)[[1]][,k]))/as.matrix(rowData(object)[[1]][,k])) * 10^6

    ppmerror <- data.frame(x = c(t(as.matrix(rowData(object)[[1]][,k]))),
                           y = c(t(deltaPPM)), 
                           sequence = rep(rownames(object)[[1]],
                                          each = ncol(assay(object))))
    return(ppmerror)
}

#' Mass error plot
#' 
#'@param object An object of class `QFeatures`
#'@param eCentroid character string indicating column identifier for 
#'experimental centroid
#'@param tCentroid character string indicating column identifier for 
#'theoretical centroid
#'@return a ggplot2 object which can be used to visualise the 
#'@md
#'@examples
#' library(RColorBrewer)
#' data("BRD4df")
#' result <- plotMassError(BRD4df, "Exp.Cent", "Theor.Cent")
#'@author Oliver Crook
#'@export
plotMassError <- function(object,
                          eCentroid = "Exp.Cent",
                          tCentroid = "Theor.Cent"){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    ppmerror <- computeMassError(object = object,
                                 eCentroid = eCentroid,
                                 tCentroid = tCentroid)
    
    
    n <- nrow(object[[1]])
    gg <- ppmerror |> ggplot(aes(x = x, y = y, col = sequence)) +
        geom_point(size = 2, alpha = 0.8) + 
        scale_color_manual(values = 
                               colorRampPalette(brewer.pal(n  = 11, 
                                                           name = "Set3"))(n)) +
        theme_classic() + 
        theme(legend.position = "none") + 
        xlab("Theoretical Centroid") + 
        ylab("Empirical Error")
    
    return(gg)
}    
#' Intensity based deviations
#' 
#' @param object An object of class `QFeatures`
#' @param fcolIntensity character to intensity intensity columns. Default is
#' "Max.Inty" and uses regular expressions to find relevant columns
#' @return The Cook's distance to characterise outleirs 
#' @md
#' @examples
#' data("BRD4df_full")
#' 
#' intensityOutliers(BRD4df_full)
#' @author Oliver Crook
#' @export
intensityOutliers <- function(object,
                              fcolIntensity = "Max.Inty"){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    ii <-  grep(pattern = "Max.Inty",
                x = rowDataNames(object)[[1]])
    intensity_mat <- as.matrix(rowData(object)[[1]][, ii])

    # Use cook's distance to detect outliers
    model <- lm(log(apply(intensity_mat, 1, var)) ~ log(apply(intensity_mat, 1, mean)))
    cookD <- cooks.distance(model)
    cookD <- data.frame(x = names(cookD), y = cookD)
    cookD$outlier <- as.character(1 * (cookD$y > 2/sqrt(nrow(cookD))))
    
    return(cookD)
    
}

#' Intensity based deviation plot
#' 
#' @param object An object of class `QFeatures`
#' @param fcolIntensity character to intensity intensity columns. Default is
#' "Max.Inty" and uses regular expressions to find relevant columns
#' @return A ggplot2 object showing intensity based outliers 
#' @md
#' @examples
#' data("BRD4df_full")
#' library(RColorBrewer)
#' 
#' plotIntensityOutliers(BRD4df_full)
#' @author Oliver Crook
#' @export
plotIntensityOutliers <- function(object,
                                  fcolIntensity = "Max.Inty"){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
 
    cookD <- intensityOutliers(object = object, fcolIntensity = fcolIntensity) 
    ggIntensity <- ggplot(cookD, aes(x = x, y = y, col = outlier)) + 
        geom_hline(aes(yintercept=0)) +
        geom_segment(aes(x, y, xend=x, yend = y-y)) + 
        theme_classic() + 
        geom_point(aes(x, y), size=3) +
        scale_color_manual(values = brewer.pal(4, name = "Set2")) + 
        geom_hline(yintercept = 2/sqrt(nrow(cookD)), color = "black") + 
        coord_flip() + 
        ylab("cook's distance") + 
        ggtitle("Intensity outliers") + 
        xlab("peptide")
    
    return(ggIntensity)
}

#' Retention time based analysis
#' @param object An object of class `QFeatures`
#' @param leftRT A character indicated pattern associated with left boundary
#' of retention time search. Default is "leftRT".
#' @param rightRT A character indicated pattern associated with right boundary
#' of retneton time search. Default is "rightRT".
#' @param searchRT The actual search retention time pattern.
#'  Default is "Search.RT"
#'  
#' @return A list indicating the retention time based outliers. 
#' @md
#' @examples
#' data("BRD4df_full")
#' 
#' rTimeOutliers(BRD4df_full)
#' @author Oliver Crook
#' @export
rTimeOutliers <- function(object,
                          leftRT = "leftRT",
                          rightRT = "rightRT",
                          searchRT = "Search.RT"){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    
    jj <- grep(pattern = rightRT, x = rowDataNames(object)[[1]])
    jj2 <- grep(pattern = leftRT, x = rowDataNames(object)[[1]])
    kk <- grep(pattern = searchRT, x = rowDataNames(object)[[1]])
    
    leftrt_mat <- as.matrix(rowData(object)[[1]][, c(jj2)])
    rightrt_mat <- as.matrix(rowData(object)[[1]][, c(jj)])
    searchrt_mat <- as.matrix(rowData(object)[[1]][, c(kk)])

    # analyse left first
    rmleft <- rowMedians(leftrt_mat)
    df <- as_tibble(leftrt_mat - rmleft)
    df$names <- rownames(leftrt_mat)
    df <- pivot_longer(df,  cols = seq.int(ncol(df)) - 1)
    colnames(df) <- c("Sequence", "Experiment", "RT_shift")
    
    # define outliers based on difference from boxplot
    df <- df |> group_by(Experiment) |> 
        mutate(IQRl = quantile(x = RT_shift, c(0.25)))
    df <- df |> group_by(Experiment) |> 
        mutate(IQRu = quantile(x = RT_shift, c(0.75)))
    df$outlier <- 1*(abs(df$RT_shift) > 1.5 * (df$IQRu - df$IQRl))
    
    rmright <- rowMedians(rightrt_mat)
    df2 <- as_tibble(rightrt_mat - rmright)
    df2$names <- rownames(rightrt_mat)
    df2 <- pivot_longer(df2,  cols = seq.int(ncol(df2)) - 1)
    colnames(df2) <- c("Sequence", "Experiment", "RT_shift")
    
    # define outliers based on difference from boxplot
    df2 <- df2 |> group_by(Experiment) |> 
        mutate(IQRl = quantile(x = RT_shift, c(0.25)))
    df2 <- df2 |> group_by(Experiment) |> 
        mutate(IQRu = quantile(x = RT_shift, c(0.75)))
    df2$outlier <- 1*(abs(df2$RT_shift) > 1.5 * (df2$IQRu - df2$IQRl))
    
    
    .out <- list(leftRT = df, rightRT = df2) 
    
    return(.out)
}


#' Retention time based analysis
#' @param object An object of class `QFeatures`
#' @param leftRT A character indicated pattern associated with left boundary
#' of retention time search. Default is "leftRT".
#' @param rightRT A character indicated pattern associated with right boundary
#' of retneton time search. Default is "rightRT".
#' @param searchRT The actual search retention time pattern.
#'  Default is "Search.RT"
#' 
#' @return a ggplot2 object showing distribution of retention time windows.
#'  
#' @md
#' @examples
#' data("BRD4df_full")
#' library(RColorBrewer)
#' 
#' plotrTimeOutliers(BRD4df_full)
#' @author Oliver Crook
#' @export
plotrTimeOutliers <- function(object,
                              leftRT = "leftRT",
                              rightRT = "rightRT",
                              searchRT = "Search.RT"){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    df <- rTimeOutliers(object = object,
                        leftRT = leftRT,
                        rightRT = rightRT,
                        searchRT = searchRT)

    n <- length(unique(df[[1]]$Experiment))
    
    gg <- df[[1]] |> ggplot(aes(x = Experiment, y = RT_shift, fill = Experiment)) +
        geom_boxplot(fill = colorRampPalette(brewer.pal(n = 9, name = "Blues"))(n)) +
        theme_classic() +
        ylab("RT left shift") + 
        coord_flip() + 
        theme(text = element_text(size = 20))
    
    gg1 <- df[[2]] |> ggplot(aes(x = Experiment, y = RT_shift, fill = Experiment)) +
        geom_boxplot(fill = colorRampPalette(brewer.pal(n = 9, name = "Blues"))(n)) + 
        theme_classic() + 
        ylab("RT right shift") + 
        coord_flip() + 
        theme(text = element_text(size = 20))
    

    return(list(leftRTgg = gg, rightRTgg = gg1))
}    

#' Monotonicity based outlier detection.
#' @param object An object of class `QFeatures`
#' @param experiment A character vector indicating the experimental conditions
#' @param timepoints A numeric vector indicating the experimental timepoints
#' 
#' @md
#' @examples
#' data("BRD4df")
#' result <- computeMonotoneStats(BRD4df, experiment = 1, timepoint = 1)
#' @author Oliver Crook
#' @export
computeMonotoneStats <- function(object,
                                 experiment = NULL,
                                 timepoints = NULL){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    monoStat <- matrix(NA,
                      ncol = nrow(assay(object)), 
                      nrow = length(experiment))
    
    for (k in seq.int(length(experiment))){
        
        # get columns for experiment
        zz <- grep(pattern = experiment[k], x = colnames(object)[[1]])
        
        for (j in seq.int(nrow(assay(object)))){
            test <- data.frame( y = assay(object)[j, zz], 
                                x = timepoints)
            res <- test |> group_by(x) |>
                summarise(Mean = mean(y, na.rm = TRUE))
            monoStat[k, j] <- sum(abs(order(res$Mean, decreasing = TRUE)
                                     - order(res$x, decreasing = TRUE)))
        }
    }
    
    df <- vector(mode = "list", length = length(experiment))
    
    for (k in seq.int(length(experiment))){
        pmult <- table(monoStat[k,])/length(monoStat[k, ])
    
        # the threshold we should apply to filer values
        wh <- min(which(cumsum(pmult) > 0.98))
        toThres <- as.numeric(names(pmult)[wh]) 
    
        df[[k]] <- data.frame(x = rownames(assay(object)), y = monoStat[k,])
        df[[k]]$outlier <- as.character(1*(df[[k]]$y >= toThres))

    }
    
    return(monotone = df)
}
#' Monotonicity based outlier detection, plot.
#' @param object An object of class `QFeatures`
#' @param experiment A character vector indicating the experimental conditions
#' @param timepoints A numeric vector indicating the experimental timepoints
#' 
#' @md
#' @examples
#' library("RColorBrewer")
#' data("BRD4df_full")
#' experiment <- c("wt", "iBET")
#' timepoints <- rep(c(0, 15, 60, 600, 3600, 14000), each = 3)
#' monoStat <- computeMonotoneStats(object = BRD4df_full,
#' experiment = experiment, 
#' timepoints = timepoints)
#' @author Oliver Crook
#' @export
plotMonotoneStat <- function(object,
                             experiment = NULL,
                             timepoints = NULL){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    df <- computeMonotoneStats(object = object,
                               experiment = experiment, 
                               timepoints = timepoints)
    
    
    ggMono <- lapply(seq.int(length(df)),
                     function(z) 
        ggplot(df[[z]], aes(x = x, y = y, col = outlier)) + 
        geom_hline(aes(yintercept=0)) +
        geom_segment(aes(x, y, xend=x, yend = y-y)) + 
        theme_classic() + 
        geom_point(aes(x, y), size=3) + 
        scale_color_manual(values = brewer.pal(4, name = "Set2")) + 
        geom_hline(yintercept = min(df[[z]]$y[df[[z]]$outlier == 1]), color = "black") + 
        coord_flip() + 
        ylab("Deviation from monotone") + 
        ggtitle(paste0("Monotonicity outliers ", experiment[z])) + 
        xlab("peptide"))
    return(ggMono)
}

#' Ion Mobility time based outlier analysis
#' 
#' @param object An object of class `QFeatures`
#' @param rightIMS A string indicating the right boundary of the
#' ion mobility separation time. Defaults is "rightIMS".
#' @param leftIMS A string indicating the left boundary of the ion mobility
#' separation time. Default is "leftIMS".
#' 
#' @param searchIMS A string indicating the actual ion mobility search time. 
#' The default is "Search.IMS"
#' @md
#' 
#' @author Oliver Crook
#' @examples
#' data("BRD4df_full")
#' BRD4df_filtered <- isMissingAtRandom(object = BRD4df_full)
#' BRD4df_full_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
#' imTimeOutlier(object = BRD4df_full_imputed)
#' 
#' @export
imTimeOutlier <- function(object,
                          rightIMS = "rightIMS",
                          leftIMS = "leftIMS",
                          searchIMS = "Search.IMS"){


    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
 
    jj <- grep(pattern = rightIMS, x = rowDataNames(object)[[1]])
    jj2 <- grep(pattern = leftIMS, x = rowDataNames(object)[[1]])
    kk <- grep(pattern = searchIMS, x = rowDataNames(object)[[1]])
    
    leftIMS_mat <- as.matrix(rowData(object)[[1]][, c(jj2)])
    rightIMS_mat <- as.matrix(rowData(object)[[1]][, c(jj)])
    searchIMS_mat <- as.matrix(rowData(object)[[1]][, c(kk)])

    imsleft <- rowMedians(leftIMS_mat)
    df <- as_tibble(leftIMS_mat - imsleft)
    df$names <- rownames(leftIMS_mat)
    df <- pivot_longer(df,  cols = seq.int(ncol(df)) - 1)
    colnames(df) <- c("Sequence", "Experiment", "IMS_shift")
    
    df <- df |> group_by(Experiment) |> 
        mutate(IQRl = quantile(x = IMS_shift, c(0.25)))
    df <- df |> group_by(Experiment) |> 
        mutate(IQRu = quantile(x = IMS_shift, c(0.75)))
    df$outlier <- 1*(abs(df$IMS_shift) > 1.5 * (df$IQRu - df$IQRl))

    rmright <- rowMedians(rightIMS_mat)
    df2 <- as_tibble(rightIMS_mat - rmright)
    df2$names <- rownames(rightIMS_mat)
    df2 <- pivot_longer(df2,  cols = seq.int(ncol(df2)) - 1)
    colnames(df2) <- c("Sequence", "Experiment", "IMS_shift")

    df2 <- df2 |> group_by(Experiment) |> 
        mutate(IQRl = quantile(x = IMS_shift, c(0.25)))
    df2 <- df2 |> group_by(Experiment) |> 
        mutate(IQRu = quantile(x = IMS_shift, c(0.75)))
    df2$outlier <- 1*(abs(df2$IMS_shift) > 1.5 * (df2$IQRu - df2$IQRl))

    
    .out <- list(leftIMS = df, rightIMS = df2) 
    
    return(.out)
}

#' Ion Mobility time based outlier analysis
#' 
#' @param object An object of class `QFeatures`
#' @param rightIMS A string indicating the right boundary of the
#' ion mobility separation time. Defaults is "rightIMS".
#' @param leftIMS A string indicating the left boundary of the ion mobility
#' separation time. Default is "leftIMS".
#' 
#' @param searchIMS A string indicating the actual ion mobility search time. 
#' The default is "Search.IMS"
#' @md
#' @author Oliver Crook
#' @examples
#' library(RColorBrewer)
#' data("BRD4df_full")
#' BRD4df_filtered <- isMissingAtRandom(object = BRD4df_full)
#' BRD4df_full_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
#' plotImTimeOutlier(object = BRD4df_full_imputed)
#' @export 
plotImTimeOutlier <- function(object,
                          rightIMS = "rightIMS",
                          leftIMS = "leftIMS",
                          searchIMS = "Search.IMS"){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    
    df <- imTimeOutlier(object = object,
                        leftIMS = leftIMS,
                        rightIMS = rightIMS,
                        searchIMS = searchIMS)
    
    n <- length(unique(df[[1]]$Experiment))
    
    gg <- df[[1]] |> ggplot(aes(x = Experiment, y = IMS_shift, fill = Experiment)) +
        geom_boxplot(fill = colorRampPalette(brewer.pal(n = 9, name = "Reds"))(n)) +
        theme_classic() + ylab("IMS left shift") + 
        coord_flip() + 
        theme(text = element_text(size = 20))
    
    gg1 <- df[[2]] |> ggplot(aes(x = Experiment, y = IMS_shift, fill = Experiment)) +
        geom_boxplot(fill = colorRampPalette(brewer.pal(n = 9, name = "Reds"))(n)) +
                         theme_classic() + ylab("IMS right shift") + 
        coord_flip() +
        theme(text = element_text(size = 20))
    
    
    return(list(leftIMSgg = gg, rightIMSgg = gg1))
}

#' Charge states should have correlated incorperation but they need not
#' be exactly the same
#' @param object An object of class `QFeatures`
#' @param experiment A character vector indicating the experimental conditions
#' @param timepoints A numeric vector indicating the experimental timepoints
#' @md
#' @examples
#' data("BRD4df_full")
#' BRD4df_filtered <- isMissingAtRandom(object = BRD4df_full)
#' BRD4df_full_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
#' experiment <- c("wt", "iBET")
#' timepoints <- rep(c(0, 15, 60, 600, 3600, 14000), each = 3)
#' monoStat <- chargeCorrelationHdx(object = BRD4df_full_imputed,
#' experiment = experiment, 
#' timepoints = timepoints)
#' @author Oliver Crook
#' @export
chargeCorrelationHdx <- function(object,
                                 experiment = NULL,
                                 timepoints = NULL){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    wh <- which(table(substr(rownames(object)[[1]], 
                             1, nchar(rownames(object)[[1]]) - 1)) > 1)
    chstate <- substr(rownames(object)[[1]], 
                      nchar(rownames(object)[[1]]),
                      nchar(rownames(object)[[1]]))
    ch <- which(substr(rownames(object)[[1]],
                       1,
                       nchar(rownames(object)[[1]]) - 1) %in% names(wh))
    maxch <- max(as.numeric(chstate))
    
    numDupl <- table(substr(rownames(object)[[1]], 
                            1, nchar(rownames(object)[[1]]) - 1))[wh]
    
    out <- vector(mode = "list", length = length(experiment))
    for (k in seq_along(experiment)){
      zz <- grep(pattern = experiment[k], colnames(assay(object)))
      df <- data.frame(y = c(assay(object)[ch, zz]),
                       x = rep(timepoints, each = length(ch)),
                       z = rep(chstate[ch], times = length(timepoints)),
                       peptide = rep(rep(names(numDupl),
                                         times = numDupl), times = length(zz)))
      df <- df |> group_by(x, z, peptide) |> mutate(replicate = row_number())
      df_2 <- df |> dplyr::filter(x != 0) |> pivot_wider(id_cols = c("x", "replicate", "peptide"),
                                                names_from = c(z),
                                                values_from = y)
      .out <- sapply(names(wh), function(x) cor(df_2[df_2$peptide == x, -c(1,2,3)]))
      out[[k]] <- .out[seq.int(maxch),]
      rownames(out[[k]]) <- seq.int(maxch)
    }
    
    names(out) <- experiment
    return(out)
    
}

#' Check whether deuterium uptakes are compatible with difference overlapping
#' sequences.
#' @param object An object of class `QFeatures`
#' @param overlap How much overlap is required to check consistentcy. Default
#' is sequences within 5 residues
#' @param experiment A character vector indicating the experimental conditions
#' @param timepoints A numeric vector indicating the experimental timepoints
#' 
#' @md
#' @examples
#' data("BRD4df")
#' result <- compatibleUptake(BRD4df,  experiment = 1, timepoints = 1)
#' @author Oliver Crook
#' @export
compatibleUptake <- function(object,
                             overlap = 5,
                             experiment = NULL,
                             timepoints = NULL){
    
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    stopifnot("overlap must be a numeric value"=is(overlap, "numeric"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    # Get locations of peptides
    jj <- grep(pattern = "Start", x = rowDataNames(object)[[1]])
    jj2 <- grep(pattern = "End", x = rowDataNames(object)[[1]])
    start_mat <- as.matrix(rowData(object)[[1]][, c(jj)])
    end_mat <- as.matrix(rowData(object)[[1]][, c(jj2)])
    
    # okay working but charge states too stringent only compare same charge.
    seqs <- sapply(seq.int(nrow(start_mat)), function(x) seq.int(start_mat[x,1], end_mat[x,1]))
    charges <- sapply(strsplit(rownames(object)[[1]], split = ""), function(x) x[length(x)])
    flagged <- list()
    
    for (j in seq.int(nrow(start_mat))){
        dout <- sapply(seq.int(nrow(start_mat)), function(x) 
            max(length(seqs[[j]]), length(seqs[[x]])) - 
                length(intersect(seqs[[j]], seqs[[x]])))
        oi <- dout[dout < overlap]
        charge_sub <- charges[dout < overlap]
        ch <- charge_sub %in% charge_sub[which(oi== 0)[1]]
        mat <- t(assay(object)[(dout < overlap), ])
        
        if (length(oi) == 1){
            next
        }
        
        d1 <- abs(mat - mat[, which(oi == 0)[1]])
        test <- sapply(seq.int(ncol(start_mat)), function(x) {d1[x,] <= dout[(dout < 5)]})  
        test <- test[ch,] # remove charge different charge state
        flagged[[j]] <- which(!test, arr.ind = TRUE)
    }
    
    flagged_df <- flagged[sapply(flagged, length) > 0]
    names(flagged_df) <- sapply(flagged_df, function(x) rownames(x)[1])
    whichtoflag <- sapply(flagged_df, function(x) x[,2])
    
    nm <- paste0(experiment, rep(timepoints, times = length(experiment)))
    whichtoflag <- sapply(whichtoflag, function(x) {
                                                 an <- names(x)
                                                 x <- nm[x]
                                                 names(x) <- an
                                                 return(x)})             
    
    return(whichtoflag)
}

#' Spectral checking using data from HDsite
#' 
#' @param peaks a data.frame containing data exported from hdsite
#' @param object a data.frame obtained from HDexaminer data 
#' @param experiment A character vector indicating the experimental conditions
#' @param mzCol The column in the peak information indicating the base mz value
#' @param startRT The column indicatng the start of the retention time. Default
#' is "Start.RT"
#' @param endRT The column indicating the end of the retention time. Default is
#' "End.RT
#' @param charge The column indicating the charge information. Default is "z".
#' @param incorpD The deuterium uptake value column. Default is "X.D.left".
#' @param maxD The maximum allowed deuterium incorporation column. Default is "maxD".
#' @param numSpectra The number of spectra to analyse. Default is NULL in which
#' all Spectra are analysed.
#' @param ppm The ppm error
#' @param BPPARAM Bioconductor parallel options. 
#' @return Two list of spectra observed and matching theoretical Spectra
#' @md
#' @author Oliver Crook
#' @export 
spectraSimilarity <- function(peaks,
                              object,
                              experiment = NULL,
                              mzCol = 14,
                              startRT = "Start.RT",
                              endRT = "End.RT",
                              charge = "z",
                              incorpD = "X.D.left",
                              maxD = "maxD",
                              numSpectra = NULL,
                              ppm = 300,
                              BPPARAM = bpparam()){
    
    stopifnot("peaks must be a data.frame"=is(peaks, "data.frame"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    
    # replace NaN with 0
    peaks[peaks == "NaN"] <- 0
    tidy.names <- make.names(colnames(peaks), unique = TRUE)
    colnames(peaks) <- tidy.names
    
    # need experimental designs
    exper <- grep(pattern = paste(experiment, collapse = "|"), peaks$Protein.State)
    peaks  <- peaks[exper, ]
    
    mzvec <- peaks[, mzCol]
    sps <- DataFrame(msLevel = rep(1L, length(mzvec)),
                     rtime =(peaks[,startRT] + peaks[,endRT]) / 2)
    
    # how many peaks are there
    # assume everything after mzCol is peaks
    k <- ncol(peaks) - mzCol
    
    sps$mz <- as.list(data.frame(t(matrix(rep(mzvec, k), ncol = k) +
                                       matrix(rep(seq.int(k) - 1,
                                                  nrow(peaks)),
                                              ncol = k,
                                              byrow =TRUE)/peaks[, charge])))
    
    sps$intensity <- as.list(data.frame(t(peaks[, -seq.int(mzCol)])))
    
    # Make Spectra object
    spd <- Spectra(sps)
    
    #spd$Sequence <- object |> filter(Protein.State %in% exper) |> pull(Sequence)
    spd$Sequence <- object |> pull(Sequence)
    spd$Charge <- peaks[, charge]
    spd$intensity <- spd$intensity/max(intensity(spd), na.rm = TRUE) #normalisation
    spd$incorp <- peaks[, incorpD]/peaks[, maxD]
    spd$incorp[sps$incorp < 0] <- 0
    
    if (is.null(numSpectra)){
        numSpectra <- length(spd$Sequence)
    }
    
    testspectra <- generateSpectra(sequences = spd$Sequence[seq.int(numSpectra)],
                                       incorps = spd$incorp[seq.int(numSpectra)],
                                       charges = spd$Charge[seq.int(numSpectra)])
    testspectra$intensity <- testspectra$intensity/max(testspectra$intensity, na.rm = TRUE)
    spectrascores <- bplapply(seq.int(numSpectra), function(z)
        Spectra::compareSpectra(x = spd[z, ],
                       y = testspectra[z, ], ppm = ppm, 
                       FUN = MsCoreUtils::navdist))
  
    spd$score <- c(unlist(spectrascores), rep(NA, times = length(spd$Sequence) - numSpectra))
    spd$experiment <- peaks$Protein.State
    spd$DeutTime <- peaks$Deut.Time
    spd$replicate <- as_tibble(spectraData(spd)) |>
        group_by(Sequence, Charge, experiment, DeutTime) |>
        mutate(replicate = row_number()) |> pull(replicate)
    
    return(list(observedSpectra = spd, matchedSpectra = testspectra))
}

#' Correlation based checks
#' 
#' @param object An object of class QFeatures.
#' @param experiment A character vector indicating the experimental conditions
#' @param timepoints A numeric vector indicating the experimental timepoints
#' @return Returns A list of the same length as the number of experiments indicating
#' outlier from correlation analysis. Outliers are flagged if their deuterium
#' uptake is highly variable.
#' 
#' @md
#' @author Oliver Crook
#' @examples
#' data("BRD4df_full")
#' experiment <- c("wt", "iBET")
#' timepoints <- rep(c(0, 15, 60, 600, 3600, 14000), each = 3)
#' monoStat <- replicateCorrelation(object = BRD4df_full,
#' experiment = experiment, 
#' timepoints = timepoints)
#' 
#' @export
replicateCorrelation <- function(object, 
                                 experiment,
                                 timepoints){

    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    corStat <- matrix(NA,
                       ncol = nrow(assay(object)), 
                       nrow = length(experiment))
    
    for (k in seq.int(length(experiment))){
        
        # get columns for experiment
        zz <- grep(pattern = experiment[k], x = colnames(object)[[1]])
        
        for (j in seq.int(nrow(assay(object)))){
            test <- data.frame( y = assay(object)[j, zz], 
                                x = timepoints)
            res <- test |> group_by(x) |> summarise(cor = var(y, use = "everything"))
            corStat[k, j] <- max(res$cor, 0)
        }
    }
    
    df <- vector(mode = "list", length = length(experiment))
    
    for (k in seq.int(length(experiment))){

        toThres <- quantile(corStat, 0.95, na.rm = TRUE)
        
        df[[k]] <- data.frame(x = rownames(assay(object)), y = corStat[k, ])
        df[[k]]$outlier <- as.character(1*(df[[k]]$y >= toThres))
        
    }
    
    return(cor = df)
}   

#' Correlation based checks
#' 
#' @param object  An object of class QFeatures.
#' @param experiment A character vector indicating the experimental conditions
#' @param timepoints A numeric vector indicating the experimental timepoints
#' @return Returns A list of the same length as the number of experiments indicating
#' outlier from correlation analysis. Outliers are flagged if their deuterium
#' uptake is highly variable.
#' 
#' @md
#' @examples
#' data("BRD4df_full")
#' BRD4df_filtered <- isMissingAtRandom(object = BRD4df_full)
#' BRD4df_full_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
#' experiment <- c("wt", "iBET")
#' timepoints <- rep(c(0, 15, 60, 600, 3600, 14000), each = 3)
#' monoStat <- replicateOutlier(object = BRD4df_full_imputed,
#' experiment = experiment, 
#' timepoints = timepoints)
#' @author Oliver Crook
#' @export
replicateOutlier <- function(object, 
                             experiment,
                             timepoints){
    
    stopifnot("Object is not a QFeatures object"=is(object, "QFeatures"))
    stopifnot("Must provide the experimental conditions"=!is.null(experiment))
    stopifnot("Must indicate the timepoints"=!is.null(timepoints))
    
    mMStat <- matrix(NA,
                      ncol = nrow(assay(object)), 
                      nrow = length(experiment))
    
    for (k in seq.int(length(experiment))){
        
        # get columns for experiment
        zz <- grep(pattern = experiment[k], x = colnames(object)[[1]])
        
        for (j in seq.int(nrow(assay(object)))){
            test <- data.frame( y = assay(object)[j, zz], 
                                x = timepoints)
            res <- test |> group_by(x) |> 
                summarise(mM = abs(mean(y, na.rm = TRUE) - median(y, na.rm = TRUE)))
            mMStat[k, j] <- max(res$mM, 0)
        }
    }
    
    df <- vector(mode = "list", length = length(experiment))
    
    for (k in seq.int(length(experiment))){
        
        toThres <- quantile(mMStat, 0.99)
        
        df[[k]] <- data.frame(x = rownames(assay(object)), y = mMStat[k, ])
        df[[k]]$outlier <- as.character(1*(df[[k]]$y >= toThres))
        
    }
    
    return(outlier = df)
}    

context("hdxmsqc tests")

library(testthat)
library(hdxmsqc) 
library(QFeatures)

test_that("Input validation fails for incorrect types", {
  expect_error(processHDE("not_a_dataframe"), "Not a data.frame")
})


sample_data <- data.frame(read.csv(system.file("extdata",
                                               "ELN55049_AllResultsTables_Uncurated.csv",
                                                                package = "hdxmsqc",
                                               mustWork = TRUE), nrows = 10))

test_that("Unique counts are correctly calculated", {

  result <- processHDE(sample_data)
  
  expect_true(nrow(result) == 10)
  expect_true(length(unique(result$Sequence)) == 10)
  
})

test_that("n/a values are correctly converted to NA", {
  
  result <- processHDE(sample_data)
  expect_true(all(is.na(result[result == "n/a"])))
})

result <- processHDE(sample_data)
i <- grep(pattern = "X..Deut",
          x = names(result))


sample_qfeatures <- readQFeatures(assayData = result,
                        ecol = i,
                        names = "Deuteration",
                        fnames = "fnames")


test_that("isMissingAtRandom stops with non-QFeatures input", {
  expect_error(isMissingAtRandom("not_a_qfeatures"), "Object is not a QFeatures object")
})

test_that("isMissingAtRandom applies default threshold correctly", {
  # Modify 'sample_qfeatures' to have a known distribution of NA values for testing
  modified_qfeatures <- sample_qfeatures # Apply modifications as needed
  result <- isMissingAtRandom(modified_qfeatures)

  expect_equal(nrow(assay(result)), 0)
  
})

test_that("isMissingAtRandom respects custom threshold", {
  custom_threshold <- 5 # Set this based on your data's structure
  result <- isMissingAtRandom(sample_qfeatures, threshold = custom_threshold)
  # Verify that features are filtered based on the custom threshold
  expect_equal(nrow(assay(result)), 10)
})

test_that("isMissingAtRandom filters features correctly", {
  result_with_filter <- isMissingAtRandom(sample_qfeatures, filter = TRUE)
  result_without_filter <- isMissingAtRandom(sample_qfeatures, filter = FALSE)
  
  # Check that the 'mnar' column is added and that filtering behaves as expected
  expect_true("mnar" %in% colnames(rowData(result_with_filter)[[1]]))
  expect_true("mnar" %in% colnames(rowData(result_without_filter)[[1]]))
})

test_that("computeMassError stops with non-QFeatures input", {
  expect_error(computeMassError("not_a_qfeatures"), "Object is not a QFeatures object")
})

test_that("computeMassError calculates mass error correctly", {
  # Pre-calculate expected results for a known set of experimental and theoretical centroids in 'sample_qfeatures'
  expected_delta_ppm <- 1000 # your pre-calculated delta PPM values
    result <- computeMassError(sample_qfeatures)
  # Compare calculated deltaPPM against expected values
  calculated_delta_ppm <- result$y # Assuming 'y' is the column with delta PPM values
  expect_true(all(abs(calculated_delta_ppm) < expected_delta_ppm))
})

test_that("computeMassError returns data frame with correct structure", {
  result <- computeMassError(sample_qfeatures)
  expected_columns <- c("x", "y", "sequence")
  expect_true(all(names(result) %in% expected_columns), "Returned data frame does not have the expected columns")
  expect_true(is.data.frame(result), "Returned object is not a data frame")
})

---
title: "qc-tidying"
author:
- name: Oliver M. Crook
package: hdxmsqc
output:
  BiocStyle::html_document:
    toc_float: yes
abstract: "This vignette describes how to pefrom quality control for
 mass-spectrometry based  hydrogen deuterium exchange experiment. \n"
vignette: |
  %\VignetteIndexEntry{Qualityt control for differential hydrogen deuterium exchange mass spectrometry data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteKeywords{Mass Spectrometry, MS, MSMS, Proteomics, Metabolomics, Infrastructure, Quantitative} 
  %\VignetteEncoding{UTF-8}
---

# Introduction

The `hdxmsqc` package is a quality control assessment package
from hydrogen-deuterium exchange mass-spectrometry (HDX-MS) data. The functions
look for outliers in retention time and ion mobility. They also examine missing
values, mass errors, intensity based outliers, deviations of the data from
monotonicity, the correlation of charge states, whether uptake values
are coherent based on overlapping peptides and finally the similarity of the
observed to the theoretical spectra observed. This package is designed
to help those performing iterative quality control through manual inspection
but also a set of metric and visualizations by which practitioners can use
to demonstrate they have high quality data. 


# packages

The packages required are the following.

```{r,}
suppressMessages(require(hdxmsqc))
require(S4Vectors)
suppressMessages(require(dplyr))
require(tidyr)
require(QFeatures)
require(RColorBrewer)
require(ggplot2)
require(MASS)
require(pheatmap)
require(Spectra)
require(patchwork)

```

# Data

We first load the data, as exported from HDExaminer. 

```{r,}
BRD4uncurated <- data.frame(read.csv(system.file("extdata", "ELN55049_AllResultsTables_Uncurated.csv", package = "hdxmsqc", mustWork = TRUE)))
```

The following code chunk tidies dataset, which improves the formatting and converts
to wide format. It will also note the number of states, timepoints and peptides.
```{r,}
BRD4uncurated_wide <- processHDE(HDExaminerFile = BRD4uncurated,
                                 proteinStates = c("wt", "iBET"))
```
The next code chunk extracts the columns with the quantitative data. 
```{r,}
i <- grep(pattern = "X..Deut",
          x = names(BRD4uncurated_wide))
```

We now parse the object into an object of class `Qfeatures`. This standardises
the formatting of the data.
```{r,}
BRD4df <- readQFeatures(assayData = BRD4uncurated_wide,
                        ecol = i,
                        names = "Deuteration",
                        fnames = "fnames")
```

# Visualisation

A simple heatmap of our data can give us a sense of it.

```{r,}
pheatmap(assay(BRD4df), cluster_rows = FALSE, scale = "row")
```

# Examining missing values

Here, we can plot where the missing values are:
```{r,}
plotMissing(object = BRD4df)
```

Here, we can filter data that is not missing at random:
```{r,}
BRD4df_filtered <- isMissingAtRandom(object = BRD4df)
```
We can then replot missing-ness:

```{r,}
plotMissing(object = BRD4df_filtered)
```
The values that are missing are all at the zero time-points where deuterium
uptake should be 0, we can simply impute these values.

```{r,}
BRD4df_filtered_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
```

# Empirical vs Theoretical errors



```{r,}
massError <- computeMassError(object = BRD4df_filtered_imputed)
plotMassError(object = BRD4df_filtered_imputed)
```

# Intensity based outlier detection

Using linear-model based outlier detection we see whether there
are Spectra that have variable intensity based on their mean intensity. A linear
model is fitted to the log-mean and log-variance of the intensities. These
should follow a linear trend. Cook's distance is used to determine outliers are
consider if their distance is greater than 2/$\sqrt(n)$, where $n$ is the 
number of peptides.

```{r,}
intensityOutlier <- intensityOutliers(object = BRD4df_filtered_imputed)
plotIntensityOutliers(object = BRD4df_filtered_imputed)
```

# Retention time analysis

Retention time outlier detection looks at the
usual variability of retention time search window and the
actual left/right windows of the retention time. Outliers are flagged
if their retention time falls outside 1.5 * interquartile range.

```{r,}
dfrt <- rTimeOutliers(object = BRD4df_filtered_imputed)
plotrTimeOutliers(object = BRD4df_filtered_imputed)
```

# Monotonicity statistics 

This uses a statistic to detect differences from monotonic behavior. First,
we need to specify the experimental design and the timepoints used. 

```{r,}
experiment <- c("wt", "iBET")
timepoints <- rep(c(0, 15, 60, 600, 3600, 14000), each = 3)
```

The monotonicity statistic measure the deviation from monotoncity. Whilst
some deviation is expected from random fluctuations, it is worth double
checking those that are strong deviates compare to the rest of the data.

```{r,}
monoStat <- computeMonotoneStats(object = BRD4df_filtered_imputed,
                                 experiment = experiment, 
                                 timepoints = timepoints)
out <- plotMonotoneStat(object = BRD4df_filtered_imputed,
                                 experiment = experiment, 
                                 timepoints = timepoints)
out
```

# Ion Mobility Time analysis

In a similar analysis to the retention time analysis, for ion mobility time
we can also see whether there are random deviation in the ion mobility windows.
Again, we define outliers that deviate outside the typical 1.5 * IQR.

```{r,}
imTimeOut <- imTimeOutlier(object = BRD4df_filtered_imputed)
plotImTimeOutlier(object = BRD4df_filtered_imputed)
```

# Charge state correlation

We check that charge states are correlated. Whilst we don't expect exactly
the same before - low correlation maybe concerning.

```{r,}
csCor <- chargeCorrelationHdx(object = BRD4df_filtered_imputed,
                              experiment = experiment,
                              timepoints = timepoints)
csCor
```

# Using replicates to determine outliers and variability

```{r,}
replicateVar <- replicateCorrelation(object = BRD4df_filtered_imputed,
                                     experiment = experiment,
                                     timepoints = timepoints)

replicateOut <- replicateOutlier(object = BRD4df_filtered_imputed,
                                     experiment = experiment,
                                     timepoints = timepoints)


```



# Using sequence overlap information are uptake values compatible

We can also check whether uptakes are compatible with overlapping peptides.
The difference in uptake cannot be more different than the difference
in the number of exchangeable amides. The default methodology only checks
whether sequence with up-to 5 different exchangeable amides are compatible
to keep run-times lower. Larger difference may indicate different 
chemical changes or back-exchange properties. 

```{r,}
tocheck <- compatibleUptake(object = BRD4df_filtered_imputed,
                 experiment = experiment,
                 timepoints = timepoints)
```

# Comparison of Spectra

In this section, we can directly examine the differences between the 
theoretical spectra one would expect from the computed deuterium uptake and
the actual observed spectra. Deviations observed in the spectra could 
suggest contamination, false identifications or poor quality spectra.
A score is generated using the cosine similarity between the spectra - which
is equivalent to the normalized dot product. The spectra pairs can be 
also be visualized. 


Load in some Spectra from HDsite which should match those of HDExaminer
```{r,}

hdxsite <- data.frame(read.csv(system.file("extdata", "BRD4_RowChecked_20220628_HDsite.csv",
                                           package = "hdxmsqc", mustWork = TRUE),
                               header = TRUE, fileEncoding = 'UTF-8-BOM'))
BRD4matched <- read.csv(system.file("extdata", "BRD4_RowChecked_20220628_HDE.csv",
                                           package = "hdxmsqc", mustWork = TRUE),
                               header = TRUE, fileEncoding = 'UTF-8-BOM')
```

```{r,}
spectraCompare <- spectraSimilarity(peaks = hdxsite,
                                    object = BRD4matched, 
                                    experiment = experiment,
                                    numSpectra = NULL)
```


The scores can be accesses as follows:

```{r,}
head(spectraCompare$observedSpectra$score)
```


To visualise these spectra we can use the following function

```{r,}
plotSpectraMirror(spectraCompare$observedSpectra[1,], spectraCompare$matchedSpectra[1,], ppm = 300)
```

Finally, a summarise quality control table can be produced and saved in a
.csv file if desired.

```{r,}
qctable <- qualityControl(object = BRD4df_filtered_imputed, 
                           massError = massError,
                           intensityOutlier = intensityOutlier,
                           retentionOutlier = dfrt,
                           monotonicityStat = monoStat,
                           mobilityOutlier = imTimeOut,
                           chargeCorrelation = csCor,
                           replicateCorrelation = replicateVar,
                           replicateOutlier = replicateOut,
                           sequenceCheck = tocheck,
                           spectraCheck = spectraCompare,
                           experiment = experiment,
                           timepoints = timepoints )
```

```{r,}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{plotIntensityOutliers}
\alias{plotIntensityOutliers}
\title{Intensity based deviation plot}
\usage{
plotIntensityOutliers(object, fcolIntensity = "Max.Inty")
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{fcolIntensity}{character to intensity intensity columns. Default is
"Max.Inty" and uses regular expressions to find relevant columns}
}
\value{
A ggplot2 object showing intensity based outliers
}
\description{
Intensity based deviation plot
}
\examples{
data("BRD4df_full")
library(RColorBrewer)

plotIntensityOutliers(BRD4df_full)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{plotImTimeOutlier}
\alias{plotImTimeOutlier}
\title{Ion Mobility time based outlier analysis}
\usage{
plotImTimeOutlier(
  object,
  rightIMS = "rightIMS",
  leftIMS = "leftIMS",
  searchIMS = "Search.IMS"
)
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{rightIMS}{A string indicating the right boundary of the
ion mobility separation time. Defaults is "rightIMS".}

\item{leftIMS}{A string indicating the left boundary of the ion mobility
separation time. Default is "leftIMS".}

\item{searchIMS}{A string indicating the actual ion mobility search time.
The default is "Search.IMS"}
}
\description{
Ion Mobility time based outlier analysis
}
\examples{
library(RColorBrewer)
data("BRD4df_full")
BRD4df_filtered <- isMissingAtRandom(object = BRD4df_full)
BRD4df_full_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
plotImTimeOutlier(object = BRD4df_full_imputed)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxincoperationFourier.R
\name{generateSpectra}
\alias{generateSpectra}
\title{generate Spectra using a fourier transform}
\usage{
generateSpectra(
  sequences,
  incorps,
  charges,
  customs = list(code = NULL, elements = NULL)
)
}
\arguments{
\item{sequences}{A vector of peptide sequences}

\item{incorps}{A vector of deuterium incoperation}

\item{charges}{A vector of charge states of the peptide}

\item{customs}{Custom elements supplied as a list}
}
\value{
A Spectra object corresponding to the isotope distributions
}
\description{
generate Spectra using a fourier transform
}
\examples{
generateSpectra(sequence = "HDAEHAHEAPRKL", incorps = c(0.5), charges = 2)

}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{plotMissing}
\alias{plotMissing}
\title{missing value plot}
\usage{
plotMissing(object, ...)
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{...}{Additional arguemnts to pheatmap}
}
\value{
a pheatmap showing missing values
}
\description{
missing value plot
}
\examples{
data("BRD4df_full")
library(pheatmap)
library(RColorBrewer)

plotMissing(BRD4df_full)


}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{plotMassError}
\alias{plotMassError}
\title{Mass error plot}
\usage{
plotMassError(object, eCentroid = "Exp.Cent", tCentroid = "Theor.Cent")
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{eCentroid}{character string indicating column identifier for
experimental centroid}

\item{tCentroid}{character string indicating column identifier for
theoretical centroid}
}
\value{
a ggplot2 object which can be used to visualise the
}
\description{
Mass error plot
}
\examples{
library(RColorBrewer)
data("BRD4df")
result <- plotMassError(BRD4df, "Exp.Cent", "Theor.Cent")
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qcTable.R
\name{qualityControl}
\alias{qualityControl}
\title{Quality Control table function. Generate a table that collates quality
control metrics}
\usage{
qualityControl(
  object,
  massError = NULL,
  intensityOutlier = NULL,
  retentionOutlier = NULL,
  monotonicityStat = NULL,
  mobilityOutlier = NULL,
  chargeCorrelation = NULL,
  replicateCorrelation = NULL,
  replicateOutlier = NULL,
  sequenceCheck = NULL,
  spectraCheck = NULL,
  experiment = NULL,
  timepoints = NULL,
  undeuterated = FALSE
)
}
\arguments{
\item{object}{An object of class Qfeatures, with the data used for the analysis}

\item{massError}{The output of the \code{computeMassError} function}

\item{intensityOutlier}{The output of the \code{intensityOutliers} function}

\item{retentionOutlier}{The output of the \code{rTimeOutliers} function}

\item{monotonicityStat}{The output of the \code{computeMonotoneStats} function}

\item{mobilityOutlier}{The output of the \code{imTimeOutliers} function}

\item{chargeCorrelation}{The output of the \code{chargeCorrelationsHdx} function}

\item{replicateCorrelation}{The output of the \code{replicateCorrelation} function}

\item{replicateOutlier}{The output of the \code{replicateOutlier} function}

\item{sequenceCheck}{The output of the \code{compatibleUptake} function}

\item{spectraCheck}{The output of the \code{spectraSimiarity} function}

\item{experiment}{The experimental conditions.}

\item{timepoints}{The timepoints used in the analysis, must include repeat
for replicates}

\item{undeuterated}{A logical indicating whether only the undeuterated data
should be exported}
}
\value{
An object of class \code{DataFrame} containing a summary of the quality
control results.
}
\description{
Quality Control table function. Generate a table that collates quality
control metrics
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{replicateOutlier}
\alias{replicateOutlier}
\title{Correlation based checks}
\usage{
replicateOutlier(object, experiment, timepoints)
}
\arguments{
\item{object}{An object of class QFeatures.}

\item{experiment}{A character vector indicating the experimental conditions}

\item{timepoints}{A numeric vector indicating the experimental timepoints}
}
\value{
Returns A list of the same length as the number of experiments indicating
outlier from correlation analysis. Outliers are flagged if their deuterium
uptake is highly variable.
}
\description{
Correlation based checks
}
\examples{
data("BRD4df_full")
BRD4df_filtered <- isMissingAtRandom(object = BRD4df_full)
BRD4df_full_imputed <- impute(BRD4df_filtered, method = "zero", i = 1)
experiment <- c("wt", "iBET")
timepoints <- rep(c(0, 15, 60, 600, 3600, 14000), each = 3)
monoStat <- replicateOutlier(object = BRD4df_full_imputed,
experiment = experiment, 
timepoints = timepoints)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{plotrTimeOutliers}
\alias{plotrTimeOutliers}
\title{Retention time based analysis}
\usage{
plotrTimeOutliers(
  object,
  leftRT = "leftRT",
  rightRT = "rightRT",
  searchRT = "Search.RT"
)
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{leftRT}{A character indicated pattern associated with left boundary
of retention time search. Default is "leftRT".}

\item{rightRT}{A character indicated pattern associated with right boundary
of retneton time search. Default is "rightRT".}

\item{searchRT}{The actual search retention time pattern.
Default is "Search.RT"}
}
\value{
a ggplot2 object showing distribution of retention time windows.
}
\description{
Retention time based analysis
}
\examples{
data("BRD4df_full")
library(RColorBrewer)

plotrTimeOutliers(BRD4df_full)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{compatibleUptake}
\alias{compatibleUptake}
\title{Check whether deuterium uptakes are compatible with difference overlapping
sequences.}
\usage{
compatibleUptake(object, overlap = 5, experiment = NULL, timepoints = NULL)
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{overlap}{How much overlap is required to check consistentcy. Default
is sequences within 5 residues}

\item{experiment}{A character vector indicating the experimental conditions}

\item{timepoints}{A numeric vector indicating the experimental timepoints}
}
\description{
Check whether deuterium uptakes are compatible with difference overlapping
sequences.
}
\examples{
data("BRD4df")
result <- compatibleUptake(BRD4df,  experiment = 1, timepoints = 1)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{computeMonotoneStats}
\alias{computeMonotoneStats}
\title{Monotonicity based outlier detection.}
\usage{
computeMonotoneStats(object, experiment = NULL, timepoints = NULL)
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{experiment}{A character vector indicating the experimental conditions}

\item{timepoints}{A numeric vector indicating the experimental timepoints}
}
\description{
Monotonicity based outlier detection.
}
\examples{
data("BRD4df")
result <- computeMonotoneStats(BRD4df, experiment = 1, timepoint = 1)
}
\author{
Oliver Crook
}

\name{hdxmsqc}
\alias{hdxmsqc}
\title{A package to perfrom quality control for
  mass-spectrometry based hydrogen deuterium exchange experiment.}
\description{
  `hdxmsqc` provides the functionality to assess the quality and perform
  quality control of HDX-MS experiments. Raw and processed data can be
  visualized and analyzed to identify potential issues with the data. The 
  package is designed to work with data from any HDX-MS platform. Typically,
  users will have exported results from either HDExaminer or DynamX software.
  There is not need to filter the data in either of those software systems.
}
\author{
  Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{BRD4df_full}
\alias{BRD4df_full}
\title{This is data to be included in my package}
\description{
A complete HDX-MS dataset for BRD4 in apo state and in complex with IBET151
}
\author{
My Name \email{ococrook@gmail.com}
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxincoperationFourier.R
\name{exchangeableAmides}
\alias{exchangeableAmides}
\title{Compute exchangeable amides.}
\usage{
exchangeableAmides(sequence)
}
\arguments{
\item{sequence}{The sequence of the peptide}
}
\value{
Returns a numeric indicating the number of exchangeable amides
}
\description{
Computes the number of exchangeable amides based on the sequnece
}
\examples{

exchangeableAmides(sequence = "HDAEHAHEAPRKL")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{processHDE}
\alias{processHDE}
\title{Function to curate and HDExaminer file so that in contains all the information
in a sensible format. This object can then be straightforwardly passed to
a object of class \code{QFeatures}}
\usage{
processHDE(HDExaminerFile, proteinStates = NULL)
}
\arguments{
\item{HDExaminerFile}{an object of class data.frame containing an HDExaminer
data}

\item{proteinStates}{a character vector indicating the protein states}
}
\value{
A wide format data frame with HDExaminer data
}
\description{
Function to curate and HDExaminer file so that in contains all the information
in a sensible format. This object can then be straightforwardly passed to
a object of class \code{QFeatures}
}
\examples{
sample_data <- data.frame(read.csv(system.file("extdata", "ELN55049_AllResultsTables_Uncurated.csv", package = "hdxmsqc", mustWork = TRUE), nrows = 10))

processHDE(sample_data) 

}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{intensityOutliers}
\alias{intensityOutliers}
\title{Intensity based deviations}
\usage{
intensityOutliers(object, fcolIntensity = "Max.Inty")
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{fcolIntensity}{character to intensity intensity columns. Default is
"Max.Inty" and uses regular expressions to find relevant columns}
}
\value{
The Cook's distance to characterise outleirs
}
\description{
Intensity based deviations
}
\examples{
data("BRD4df_full")

intensityOutliers(BRD4df_full)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxincoperationFourier.R
\name{fourierIsotope}
\alias{fourierIsotope}
\title{fourier transform approach to computing isotopic distribution}
\usage{
fourierIsotope(
  elements,
  incorp = 0,
  num_exch_sites = 0,
  charge = 1,
  isotopes = NULL
)
}
\arguments{
\item{elements}{A list of elements}

\item{incorp}{The deuterium incoperation}

\item{num_exch_sites}{The number of exchangable amides. Default is 0.}

\item{charge}{The charge state of the peptide}

\item{isotopes}{The number of isotopes to compute. The default is NULL, in whiich
a default heuristic is used to make a good guess that covers the expected peaks.}
}
\value{
A list of mass and intensity value corresponding to the isotope distribution
}
\description{
fourier transform approach to computing isotopic distribution
}
\examples{
fourierIsotope(c(C = 0, H = 2, N = 0, O = 1, S = 0, P = 0))

}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxincoperationFourier.R
\name{isotopicDistributionHDXfourier}
\alias{isotopicDistributionHDXfourier}
\title{fourier transform approach to computing isotopic distribution}
\usage{
isotopicDistributionHDXfourier(
  sequence,
  incorp = 0,
  charge = 1,
  custom = list(code = NULL, elements = NULL)
)
}
\arguments{
\item{sequence}{A peptide}

\item{incorp}{The deuterium incoperation}

\item{charge}{The charge state of the peptide}

\item{custom}{custom amino acids can be provided here provide a list
of the elements.}
}
\value{
A list of mass and intensity value corresponding to the isotope distribution
}
\description{
fourier transform approach to computing isotopic distribution
}
\examples{
isotopicDistributionHDXfourier(sequence = "HDAEHAHEAPRKL")
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{computeMassError}
\alias{computeMassError}
\title{Empirical versus theoretical mass errors}
\usage{
computeMassError(object, eCentroid = "Exp.Cent", tCentroid = "Theor.Cent")
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{eCentroid}{character string indicating column identifier for
experimental centroid}

\item{tCentroid}{character string indicating column identifier for
theoretical centroid}
}
\value{
The error difference between the empirical and theoretical centroid
}
\description{
Empirical versus theoretical mass errors
}
\examples{
data("BRD4df")
result <- computeMassError(BRD4df, "Exp.Cent", "Theor.Cent")
head(result)
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{isMissingAtRandom}
\alias{isMissingAtRandom}
\title{Missing at random versus missing not at random}
\usage{
isMissingAtRandom(object, threshold = NULL, filter = TRUE)
}
\arguments{
\item{object}{An object of class \code{QFeatures}}

\item{threshold}{A threshold indicated how many missing values indicate
whether missingness is not at random. Default is NULL, which means leads to a
threshold which is half the number of columns.}

\item{filter}{A logial indicating whether to filter out data that is deemed
missing not at random

data("BRD4df_full")

isMissingAtRandom(BRD4df_full)}
}
\value{
Adds a missing not at random indicator column
}
\description{
Missing at random versus missing not at random
}
\author{
Oliver Crook
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdxmsqc-utils.R
\name{spectraSimilarity}
\alias{spectraSimilarity}
\title{Spectral checking using data from HDsite}
\usage{
spectraSimilarity(
  peaks,
  object,
  experiment = NULL,
  mzCol = 14,
  startRT = "Start.RT",
  endRT = "End.RT",
  charge = "z",
  incorpD = "X.D.left",
  maxD = "maxD",
  numSpectra = NULL,
  ppm = 300,
  BPPARAM = bpparam()
)
}
\arguments{
\item{peaks}{a data.frame containing data exported from hdsite}

\item{object}{a data.frame obtained from HDexaminer data}

\item{experiment}{A character vector indicating the experimental conditions}

\item{mzCol}{The column in the peak information indicating the base mz value}

\item{startRT}{The column indicatng the start of the retention time. Default
is "Start.RT"}

\item{endRT}{The column indicating the end of the retention time. Default is
"End.RT}

\item{charge}{The column indicating the charge information. Default is "z".}

\item{incorpD}{The deuterium uptake value column. Default is "X.D.left".}

\item{maxD}{The maximum allowed deuterium incorporation column. Default is "maxD".}

\item{numSpectra}{The number of spectra to analyse. Default is NULL in which
all Spectra are analysed.}

\item{ppm}{The ppm error}

\item{BPPARAM}{Bioconductor parallel options.}
}
\value{
Two list of spectra observed and matching theoretical Spectra
}
\description{
Spectral checking using data from HDsite
}
\author{
Oliver Crook
}
